package com.totopia.server.modules.game.service;

import com.totopia.server.commons.exception.ResourceNotFoundException;
import com.totopia.server.modules.game.entity.LeagueEntity;
import com.totopia.server.modules.game.repository.LeagueRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

@Service
public class LeagueService {

  @Autowired
  private LeagueRepository leagueRepository;

  public LeagueEntity save(LeagueEntity leagueEntity) {
    return this.leagueRepository.save(leagueEntity);
  }

  public LeagueEntity modify(LeagueEntity leagueEntity) {
    return this.leagueRepository.save(leagueEntity);
  }

  public Page<LeagueEntity> getAllLeagueByPageable(Pageable pageable) {
    Page<LeagueEntity> entities = null;

//    if (null == username) {
      entities = leagueRepository.findAll(pageable);
//    } else {
//      entities = userRepository.findByUsernameContainingIgnoreCase(username, pageable);
//    }

    return entities;
  }

  public Long removeById(Long leagueId) {
    return leagueRepository.findById(leagueId).map(league -> {
      leagueRepository.delete(league);
      return leagueId;
    }).orElseThrow(() -> new ResourceNotFoundException("League", "leagueId", leagueId));
  }

  public void getLeagueById() {}
}
